# -*- coding: utf-8 -*-
# Copyright 2009-2014, Red Hat, Inc.
# License: GPL-2.0+ <http://spdx.org/licenses/GPL-2.0+>
# See the LICENSE file for more details on Licensing

from __future__ import absolute_import
import subprocess as sub
from libtaskotron.directives import BaseDirective
from libtaskotron.logger import log
from libtaskotron.exceptions import TaskotronDirectiveError

directive_class = 'CreaterepoDirective'


class CreaterepoDirective(BaseDirective):
    def process(self, input_data, env_data):
        """For the createrepo directive, we're expecting a yaml declaration of
        the form ``createrepo: repodir=/path/to/some/dir``
        """

        repodir = input_data['repodir']

        log.info('running createrepo on %s', repodir)

        p = sub.Popen(['createrepo', repodir], stdout=sub.PIPE, stderr=sub.PIPE)

        output, errors = p.communicate()

        if p.returncode:
            raise TaskotronDirectiveError(errors)

        log.debug(output)

        return output
